import * as tslib_1 from "tslib";
import * as React from 'react';
import { ensureEnum, brushToString, stringToBrush, initializePropertiesFromCss, NamePatcher, isValidProp, toSpinal, getModifiedProps } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { ReactRenderer } from "igniteui-react-core";
import { delegateCombine, delegateRemove } from "igniteui-react-core";
import { Calendar } from './Calendar';
import { IgrValueChangedEventArgs } from "./igr-value-changed-event-args";
import { ControlDisplayDensity_$type } from "igniteui-react-core";
import { BaseControlTheme_$type } from "igniteui-react-core";
var IgrCalendar = /** @class */ /*@__PURE__*/ (function (_super) {
    tslib_1.__extends(IgrCalendar, _super);
    function IgrCalendar(props) {
        var _this = _super.call(this, props) || this;
        _this._implementation = null;
        _this.__p = null;
        _this._hasUserValues = new Set();
        _this._stylingContainer = null;
        _this._stylingParent = null;
        _this._inStyling = false;
        _this._valueChanged = null;
        _this._valueChanged_wrapped = null;
        if (_this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(_this));
        }
        _this._getMainRef = _this._getMainRef.bind(_this);
        _this._implementation = _this.createImplementation();
        var calendar = _this.i;
        _this._calendar = calendar;
        calendar.notifySizeChanged();
        if (props) {
            _this.initializeProperties();
        }
        return _this;
    }
    Object.defineProperty(IgrCalendar.prototype, "height", {
        get: function () {
            return this._height;
        },
        set: function (value) {
            this._height = value;
            if (this._elRef) {
                this._elRef.style.height = value;
                this._calendar.notifySizeChanged();
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalendar.prototype, "width", {
        get: function () {
            return this._width;
        },
        set: function (value) {
            this._width = value;
            if (this._elRef) {
                this._elRef.style.height = value;
                this._calendar.notifySizeChanged();
            }
        },
        enumerable: true,
        configurable: true
    });
    IgrCalendar.prototype._getMainRef = function (ref) {
        this._elRef = ref;
        if (this._elRef != null) {
            this._renderer = new ReactRenderer(this._elRef, document, false, null);
            this._calendar.provideContainer(this._renderer);
        }
    };
    IgrCalendar.prototype.render = function () {
        var children = [];
        var div = React.createElement("div", {
            className: "ig-calendar igr-calendar",
            ref: this._getMainRef,
            children: children
        });
        return div;
    };
    IgrCalendar.prototype.shouldComponentUpdate = function (nextProps, nextState) {
        var e_1, _a;
        var mod = getModifiedProps(this.props, nextProps);
        try {
            for (var _b = tslib_1.__values(Object.keys(mod)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var p = _c.value;
                if (isValidProp(this, p)) {
                    this[p] = mod[p];
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        return true;
    };
    IgrCalendar.prototype.initializeProperties = function () {
        var e_2, _a;
        try {
            for (var _b = tslib_1.__values(Object.keys(this.props)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var p = _c.value;
                if (isValidProp(this, p)) {
                    this[p] = this.props[p];
                }
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
    };
    // supports angular themes or custom properties set in CSS
    IgrCalendar.prototype.updateStyle = function () {
        this._styling(this._elRef, this);
    };
    IgrCalendar.prototype.componentWillUnmount = function () {
        this._calendar.destroy();
        if (this._renderer) {
            this._renderer.destroy();
        }
    };
    IgrCalendar.prototype.componentDidMount = function () {
        this._elRef.style.width = this._width ? this._width : "";
        this._elRef.style.height = this._height ? this._height : "";
        this._calendar.notifySizeChanged();
        this.initializeContent();
    };
    IgrCalendar.prototype.initializeContent = function () {
        this.updateStyle();
        this.i.notifySizeChanged();
    };
    IgrCalendar.prototype.createImplementation = function () {
        return new Calendar();
    };
    Object.defineProperty(IgrCalendar.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalendar.prototype, "value", {
        /**
     * Gets or Sets the value for the calendar.
    */
        get: function () {
            return this.i.u;
        },
        set: function (v) {
            this.i.u = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalendar.prototype, "density", {
        /**
         * Gets or sets the display density to use for the calendar.
        */
        get: function () {
            return this.i.d;
        },
        set: function (v) {
            this.i.d = ensureEnum(ControlDisplayDensity_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalendar.prototype, "baseTheme", {
        /**
         * Gets or sets the base built in theme to use for the calendar.
        */
        get: function () {
            return this.i.b;
        },
        set: function (v) {
            this.i.b = ensureEnum(BaseControlTheme_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalendar.prototype, "backgroundColor", {
        /**
         * Gets or Sets the selected date background color
        */
        get: function () {
            return brushToString(this.i.bv);
        },
        set: function (v) {
            this.i.bv = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalendar.prototype, "selectedDateBackgroundColor", {
        /**
         * Gets or Sets the selected date background color
        */
        get: function () {
            return brushToString(this.i.b0);
        },
        set: function (v) {
            this.i.b0 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalendar.prototype, "selectedFocusDateBackgroundColor", {
        /**
         * Gets or Sets the selected date background color
        */
        get: function () {
            return brushToString(this.i.b2);
        },
        set: function (v) {
            this.i.b2 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalendar.prototype, "focusDateBackgroundColor", {
        /**
         * Gets or Sets the focus date background color
        */
        get: function () {
            return brushToString(this.i.bx);
        },
        set: function (v) {
            this.i.bx = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalendar.prototype, "hoverBackgroundColor", {
        /**
         * Gets or Sets the focus date background color
        */
        get: function () {
            return brushToString(this.i.bz);
        },
        set: function (v) {
            this.i.bz = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalendar.prototype, "textColor", {
        /**
         * Gets or Sets the selected date text color
        */
        get: function () {
            return brushToString(this.i.b3);
        },
        set: function (v) {
            this.i.b3 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalendar.prototype, "selectedDateTextColor", {
        /**
         * Gets or Sets the selected date text color
        */
        get: function () {
            return brushToString(this.i.b1);
        },
        set: function (v) {
            this.i.b1 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalendar.prototype, "focusDateTextColor", {
        /**
         * Gets or Sets the focus date text color
        */
        get: function () {
            return brushToString(this.i.by);
        },
        set: function (v) {
            this.i.by = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalendar.prototype, "currentDateTextColor", {
        /**
         * Gets or Sets the current date text color
        */
        get: function () {
            return brushToString(this.i.bw);
        },
        set: function (v) {
            this.i.bw = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalendar.prototype, "textStyle", {
        /**
         * Gets or sets the font to use for the combobox.
        */
        get: function () {
            if (this.i.l == null) {
                return null;
            }
            return this.i.l.fontString;
        },
        set: function (v) {
            var fi = new FontInfo();
            fi.fontString = v;
            this.i.l = fi;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalendar.prototype, "hasUserValues", {
        get: function () {
            return this._hasUserValues;
        },
        enumerable: true,
        configurable: true
    });
    IgrCalendar.prototype.__m = function (propertyName) {
        if (!this._inStyling) {
            this._hasUserValues.add(propertyName);
        }
    };
    IgrCalendar.prototype._styling = function (container, component, parent) {
        if (this._inStyling) {
            return;
        }
        this._inStyling = true;
        this._stylingContainer = container;
        this._stylingParent = component;
        var genericPrefix = "";
        var typeName = this.i.$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("Calendar");
        var additionalPrefixes = [];
        var prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        var b = this.i.$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            var basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            var parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            var parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
        if (this._otherStyling) {
            this._otherStyling(container, component, parent);
        }
        this._inStyling = false;
    };
    /**
 * Exports visual information about the current state of the grid.

*/
    IgrCalendar.prototype.exportVisualModel = function () {
        var iv = this.i.x();
        return (iv);
    };
    /**
     * Returns a serialized copy of the exported visual model
    
    */
    IgrCalendar.prototype.exportSerializedVisualModel = function () {
        var iv = this.i.af();
        return (iv);
    };
    Object.defineProperty(IgrCalendar.prototype, "valueChanged", {
        /**
         * Called when date is selected.
        */
        get: function () {
            return this._valueChanged;
        },
        set: function (ev) {
            var _this = this;
            if (this._valueChanged_wrapped !== null) {
                this.i.valueChanged = delegateRemove(this.i.valueChanged, this._valueChanged_wrapped);
                this._valueChanged_wrapped = null;
                this._valueChanged = null;
            }
            this._valueChanged = ev;
            this._valueChanged_wrapped = function (o, e) {
                var outerArgs = new IgrValueChangedEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeValueChanged) {
                    _this.beforeValueChanged(_this, outerArgs);
                }
                if (_this._valueChanged) {
                    _this._valueChanged(_this, outerArgs);
                }
            };
            this.i.valueChanged = delegateCombine(this.i.valueChanged, this._valueChanged_wrapped);
        },
        enumerable: true,
        configurable: true
    });
    return IgrCalendar;
}(React.Component));
export { IgrCalendar };
//# sourceMappingURL=igr-calendar.js.map
